/*
    Copyright 2021, Prusa Research s.r.o.

    This file is part of touch-ui

    touch-ui is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

import QtQuick 2.12

MouseArea {
    id: root
    anchors.fill: parent
    property int swipeStartX: 0
    property int swipeStartY: 0
    property bool swipeInProgress: false
    property bool swipeDownTresholdReached: false
    property bool swipeUpTresholdReached: false
    property int treshold: 20

    signal swipeUp()
    signal swipeDown()

    function startSwipe() {
        swipeStartX = mouseX
        swipeStartY = mouseY
        swipeInProgress = true
    }

    function endSwipe() {
        swipeStartX = 0
        swipeStartY = 0
        swipeInProgress = false
        swipeDownTresholdReached = false
        swipeUpTresholdReached = false
    }

    function swipeDownTreshold() {
        swipeDownTresholdReached = true
        root.swipeDown()
    }

    function swipeUpTreshold() {
        swipeUpTresholdReached = true
        root.swipeUp()        
    }

    propagateComposedEvents: true
    onPressed: () => startSwipe()
    onExited: () => endSwipe()
    onReleased: () => endSwipe()
    onCanceled: () => endSwipe()
    onMouseYChanged: () => {
        if(swipeInProgress && ! swipeDownTresholdReached && (mouseY-swipeStartY) > root.treshold) {
            swipeDownTreshold()
        }
        else if(swipeInProgress && ! swipeUpTresholdReached && (mouseY-swipeStartY) < - root.treshold) {
            swipeUpTreshold()
        }
    }
}
